import { OperationDefinitionNode } from 'graphql';
import { ReactQueryVisitor } from './visitor.js';
export declare class BaseFetcherRenderer {
    protected visitor: ReactQueryVisitor;
    constructor(visitor: ReactQueryVisitor);
    generateQueryVariablesSignature(hasRequiredVariables: boolean, operationVariablesTypes: string): string;
    generateInfiniteQueryVariablesSignature(hasRequiredVariables: boolean, operationVariablesTypes: string): string;
    generateInfiniteQueryOptionsSignature(infiniteQueryOptions: string, operationResultType: string): string;
    generateInfiniteQueryKey(node: OperationDefinitionNode, hasRequiredVariables: boolean): string;
    generateInfiniteQueryKeyMaker(node: OperationDefinitionNode, operationName: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    generateInfiniteQueryRootKeyMaker(node: OperationDefinitionNode, operationName: string): string;
    generateQueryKey(node: OperationDefinitionNode, hasRequiredVariables: boolean): string;
    generateQueryKeyMaker(node: OperationDefinitionNode, operationName: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    generateQueryRootKeyMaker(node: OperationDefinitionNode, operationName: string): string;
    generateMutationKey(node: OperationDefinitionNode): string;
    generateMutationKeyMaker(node: OperationDefinitionNode, operationName: string): string;
    generateInfiniteQueryRequired(): "?" | "";
    generateInfiniteQueryFormattedParameters(queryKey: string, queryFn: string): string;
    generateQueryFormattedParameters(queryKey: string, queryFn: string): string;
    generateMutationFormattedParameters(mutationKey: string, mutationFn: string): string;
}
export declare abstract class FetcherRenderer extends BaseFetcherRenderer {
    abstract generateFetcherImplementaion(): string;
    abstract generateQueryHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    abstract generateInfiniteQueryHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    abstract generateMutationHook(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
    abstract generateFetcherFetch(node: OperationDefinitionNode, documentVariableName: string, operationName: string, operationResultType: string, operationVariablesTypes: string, hasRequiredVariables: boolean): string;
}
